<?php
/*

BBS Netaxept Payment Module 0.9 BETA for Zen Cart 1.3.8, developed by BBS AS.
This module uses the WebService API developed by BBS.
BBS will not provide any official support on this module.
We appreciate if you contact us about errors or future improvments on this module.

BBS AS
Haavard Martinsens Vei 54
0978 Oslo
Norway
kundeservice@netaxept.no

Check the documentation on www.netaxept.no for further information.
Errors may occur. Use at your own risk.

Released under the GNU General Public License
*/

require('includes/application_top.php');

// if the customer is not logged on, redirect them to the login page
if (!$_SESSION['customer_id']) {
	$navigation->set_snapshot(array('mode' => 'SSL', 'page' => FILENAME_CHECKOUT_PAYMENT));
	zen_redirect(zen_href_link(FILENAME_LOGIN, '', 'SSL'));
}

// if there is nothing in the customers cart, redirect them to the shopping cart page
//if ($cart->count_contents() < 1) {
//        zen_redirect(zen_href_link(FILENAME_SHOPPING_CART));
//}

// if no shipping method has been selected, redirect the customer to the shipping method selection page
if (!$_SESSION['shipping'] || !$_SESSION['sendto']) {
	zen_redirect(zen_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
}

if ( (zen_not_null(MODULE_PAYMENT_INSTALLED)) && (!$_SESSION['payment']) ) {
	zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
}

// avoid hack attempts during the checkout procedure by checking the internal cartID
if (isset($cart->cartID) && $_SESSION['cartID']) {
	if ($cart->cartID != $cartID) {
		zen_redirect(zen_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
	}
}

include(DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_PROCESS);
// load selected payment module
require(DIR_WS_CLASSES . 'payment.php');
$payment_modules = new payment($payment);

// load the selected shipping module
require(DIR_WS_CLASSES . 'shipping.php');
$shipping_modules = new shipping($shipping);

require(DIR_WS_CLASSES . 'order.php');
$order = new order;
 
require(DIR_WS_CLASSES . 'order_total.php');
$order_total_modules = new order_total;

$order_totals = $order_total_modules->process();

#############################  START BBS NETAXEPT CODE  #############################

####  NEW WS CODE HERE  ###########################################################################


$result_process_setup = null;
$result_auth_sale = null;
$transactionId = null;
$zen_order_id = null;
$response = null;
$zenid = null;
$error_message = null;
$url = HTTP_SERVER . DIR_WS_CATALOG."index.php?main_page=checkout_success";

global $db;

####  RUN PROCESS SETUP  ####
$result_process_setup = runProcessSetup();

if ( preg_match( "/ERROR/", $result_process_setup )) {
	$error_message = "ERROR";
	completePayment($url, $error_message);
}
else if ( preg_match( "/CANCEL/", $result_process_setup ) ) {
	$error_message = "CANCEL";
	completePayment($url, $error_message);
}
else {
	$transactionId = $result_process_setup;
}


####  RUN AUTH OR SALE  ####
if ( isset($transactionId)) {
	$result_auth_sale = runAuthSale($transactionId);
	
	if ( preg_match( "/ERROR/", $result_auth_sale ) ) {
		$error_message = "ERROR";
		completePayment($url, $error_message);
	}
	else if ( preg_match( "/CANCEL/", $result_auth_sale ) ) {
		$error_message = "CANCEL";
		completePayment($url, $error_message);
	}
	else {
		$zenid = $result_auth_sale;
	}
}


####  RUN EMAIL CONFIRMATION  ####
$notify_by_email = MODULE_PAYMENT_BBS_NETAXEPT_EMAIL;
$result_send_email = "";

if ( $notify_by_email == "yes" && (int)$result_auth_sale) {
	$order_row = $db->Execute("SELECT customers_id FROM " . TABLE_ORDERS . " WHERE orders_id = "."'" .$zenid."'");
	$customer_id = $order_row->fields['customers_id'];

	$result_send_email = send_order_email($zenid, 2, $customer_id);
}

####  RUN COMPLETE PAYMENT  ####
if ( $result_send_email == "OK" ) {
	$url = HTTP_SERVER . DIR_WS_CATALOG."index.php?main_page=checkout_success";
	completePayment($url);
}
else {
	completePayment($url, $error_message);
}


####  START WS PROCESS SETUP  ####

function runProcessSetup()
{
	//echo "<br/>Start ProcessSetup - Step 1";
	global $db;

	try
	{
		$params = array
		(
	          "token"                 => MODULE_PAYMENT_BBS_NETAXEPT_TOKEN,
	          "merchantId"            => MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID,
	          "transactionString"     => $_REQUEST['BBSePay_transaction']
		);

		// WSDL location found in documentation
		$wsdl = MODULE_PAYMENT_BBS_NETAXEPT_WSDLLOCATION;

		$client = new SoapClient($wsdl, array('trace' => true,'exceptions' => true ));
		$result = $client->__call('ProcessSetup' , array("parameters"=>$params));

		$ProcessSetupResult = $result->ProcessSetupResult;
		// Get BBS Netaxept transID
		$transactionId = $ProcessSetupResult->TransactionId;

		if ($ProcessSetupResult->ResponseCode == 'OK') {
			# Transaction OK - Start doing system specific actions

			####  UPDATE TRANSACTION INFO IN DB  ####
			// Get order details from OSC order
			$order_row = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE bbs_trans_id = "."'" .$ProcessSetupResult->TransactionId."'");
			$zen_order_id = $order_row->fields['orders_id'];
			
			$sql_orders_array = array('bbs_recurringExpiryDate' => $ProcessSetupResult->CardExpiryDate,
		    	'bbs_recurringFrequenzy' => $ProcessSetupResult->RecurringFrequenzy,
		        'bbs_recurringType' => $ProcessSetupResult->Recurringtype,
		        'bbs_panHash' => $ProcessSetupResult->PanHash);
			
			zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "bbs_trans_id='".$transactionId."'");

			// Add status to history table
			$sql_orders_status_history = array('orders_id' => $zen_order_id,
		    	'orders_status_id' => 1,
		        'date_added' => 'now()',
		        'customer_notified' => 0,
		        'comments' => 'BBS ProcessSetup OK '.date("Y-m-d G:i:s"));

			zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);

			//echo "<br/>PS - Step 4";

			####  END UPDATE TRANSACTION INFO IN DB  ####

			####  END PROCESS SETUP  ####
		} // End if

		return $ProcessSetupResult->TransactionId;

	} // End try
	catch (SoapFault $fault)
	{
		//echo "<br/>PS ERROR - Step 1";
		######  ERROR HANDLING PROCESS SETUP ######
		$merchantTransactionId = 0;

		$faultstring = $fault->faultstring;
		$errorType = "error";

		if (preg_match("/Cancelled by user/", $faultstring, $matches)) {
			$merchantTransactionId = $fault->detail->UserCancelledException->Result->TransactionId;
			$errorType = "cancelexception";
		}
		else if (preg_match("/Authentication/", $faultstring, $matches)) {
			$errorType = "authenticationexception";
		}
		else {
			$merchantTransactionId = $fault->detail->BBSException->Result->TransactionId;
			$errorType = "bbsexception";
		}


		####  UPDATE TRANSACTION INFO IN DB  ####


		if ( $errorType == "bbsexception" ) {
			// Get order details from ZenCart order
			$order_row = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE bbs_trans_id = '".$merchantTransactionId."'");
			$zen_order_id = $order_row->fields['orders_id'];

			// Change order status
			$sql_orders_array = array('orders_status' =>  98);
			zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "bbs_trans_id='".$merchantTransactionId."'");
		} else if ( $errorType == "cancelexception" ) {
			// Get order details from ZenCart order
			$order_row = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE bbs_trans_id = '".$merchantTransactionId."'");
			$zen_order_id = $order_row->fields['orders_id'];

			// Change order status
			$sql_orders_array = array('orders_status' =>  99);
			zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "bbs_trans_id='".$merchantTransactionId."'");
		}

		// Add status to history table
		if ($errorType == "bbsexception") {
			////echo "</br>PS CATCH - 3.0 - bbsexception";
			$sql_orders_status_history = array('orders_id' => $zen_order_id,
            	'orders_status_id' => 98,
                'date_added' => 'now()',
                'customer_notified' => 0,
                'comments' => 'BBS ProcessSetup FAILED '.date("Y-m-d G:i:s"). 
                	' Fault: '.$fault->faultstring.
                    ' ResponseCode: '.$fault->detail->BBSException->Result->ResponseCode.
                    ' ResponseSource: '.$fault->detail->BBSException->Result->ResponseSource.
                    ' Message: '.$fault->detail->BBSException->Message);
			 
			zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);

			$error_message = 'ERROR'; //: '.MODULE_PAYMENT_BBS_NETAXEPT_ERROR_MESSAGE.'</br></br> Webshop order id: '.$zen_order_id;
		}
		else if ($errorType == "cancelexception") {
			//echo "</br>CANCEL EXCEPTION";
			$sql_orders_status_history = array('orders_id' => $zen_order_id,
            	'orders_status_id' => 99,
                'date_added' => 'now()',
                'customer_notified' => 0,
                'comments' => 'BBS ProcessSetup FAILED '.date("Y-m-d G:i:s"). 
                	' Fault: '.$fault->faultstring.
                    ' ResponseCode: '.$fault->detail->UserCancelledException->Result->ResponseCode.
                    ' ResponseSource: '.$fault->detail->UserCancelledException->Result->ResponseSource.
                    ' Message: '.$fault->detail->UserCancelledException->Message);
			 
			zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);

			$error_message = 'CANCEL'; //.MODULE_PAYMENT_BBS_NETAXEPT_CANCEL_MESSAGE.'</br></br> Webshop order id: '.$zen_order_id;
		}
		else {
			// Authentication Exception - Can't save anything to a transaction.

		}
		####  END UPDATE TRANSACTION INFO IN DB  ####
        $_SESSION['orderId'] = $zen_order_id;
		return $error_message;
		######  END ERROR HANDLING PROCESS SETUP ######
	}
}  // END PROCESS SETUP



####  START AUTH OR SALE  ####
function runAuthSale($transactionId)
{
	//echo "<br/>Start AuthSale";
	global $db;

	try
	{
		$params_sale = array
		(
        	"token"                 => MODULE_PAYMENT_BBS_NETAXEPT_TOKEN,
            "merchantId"            => MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID,
            "transactionId"         => $transactionId,
            "transactionReconRef"   => $transactionId,    // This ID is a merchant created reference local to a transaction. It is sent to issuer and is returned with settlement 
            "batchReconRef"         => ""                 // Merchant created reference wich applies to a batch. Sent to issuer and returned with settlement.                                                 // In standard implementations this should be empty.
		);

		$params_auth = array
		(
        	"token"                 => MODULE_PAYMENT_BBS_NETAXEPT_TOKEN,
            "merchantId"            => MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID,
            "transactionId"         => $transactionId,
            "transactionReconRef"   => $transactionId,    // This ID is a merchant created reference local to a transaction. It is sent to issuer and is returned with settlement 
            "batchReconRef"         => ""                 // Merchant created reference wich applies to a batch. Sent to issuer and returned with settlement. 
		// In standard implementations this should be empty.
		);

		// WSDL location found in documentation
		$wsdl = MODULE_PAYMENT_BBS_NETAXEPT_WSDLLOCATION;

		$WS_Result = "";
		$client = new SoapClient($wsdl, array('trace' => true,'exceptions' => true ));

		$operation = MODULE_PAYMENT_BBS_NETAXEPT_AUTHSALE;

		if ($operation == 'sale') {
			$result = $client->__call('Sale', array("parameters"=>$params_sale));
			$WS_Result = $result->SaleResult;
		}
		else {
			$result = $client->__call('Auth', array("parameters"=>$params_auth));
			$WS_Result = $result->AuthResult;
		}

		if ($WS_Result->ResponseCode == 'OK')
		{
			# Transaction OK - Start doing system specific actions
			####  Update status info in db  ####

			$order_row = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE bbs_trans_id = "."'" .$WS_Result->TransactionId."'");
			$zen_order_id = $order_row->fields['orders_id'];

			$sql_orders_status_history = array('orders_id' => $zen_order_id,
            	'orders_status_id' => 1,
                'date_added' => 'now()',
                'customer_notified' => 0,
                'comments' => 'BBS '.$operation.' OK '.date("Y-m-d G:i:s"));

			zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);

			####  End Update status info in db  ####
		} // End if

		return $zen_order_id;
	}
	catch(SoapFault $fault) {
		######  ERROR HANDLING AUTH OR SALE ######
		$faultstring = $fault->faultstring;
		$errorType = "error";

		if (preg_match("/Authentication/", $faultstring, $matches)) {
			$errorType = "authenticationexception";
		}
		else {
			$merchantTransactionId = $fault->detail->BBSException->Result->TransactionId;
			$errorType = "bbsexception";
		}

		####  UPDATE TRANSACTION INFO IN DB  ####
		if ( $errorType == "bbsexception"  ) {
			$merchantTransactionId = $fault->detail->BBSException->Result->TransactionId;
			// Get order details from OSC order
			$order_row = $db->Execute("SELECT orders_id FROM " . TABLE_ORDERS . " WHERE bbs_trans_id = '".$merchantTransactionId."'");
			$zen_order_id = $order_row->fields['orders_id'];

			// Change order status
			$sql_orders_array = array('orders_status' =>  98);
			zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "bbs_trans_id='".$merchantTransactionId."'");
		}
		else if ( $errorType == "authenticationexception" ) {
			// Authentication Exception: Can't be logged to a transaction.
		}

		// Add status to history table
		if ($errorType == "bbsexception") {
			$sql_orders_status_history = array('orders_id' => $zen_order_id,
            	'orders_status_id' => 98,
                'date_added' => 'now()',
                'customer_notified' => 0,
                'comments' => 'BBS '.$operation.' FAILED '.date("Y-m-d G:i:s").
                	' Fault: '.$fault->faultstring.
                    ' ResponseCode: '.$fault->detail->BBSException->Result->ResponseCode.
                    ' ResponseSource: '.$fault->detail->BBSException->Result->ResponseSource.
                    ' Message: '.$fault->detail->BBSException->Message);

			zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);
		}
		else {
			// Authentication Exception: Can't be logged to a transaction.
		}

		####  END UPDATE TRANSACTION INFO IN DB  ####
		$_SESSION['orderId'] = $zen_order_id;	
		return $error_message;
		######  END ERROR HANDLING AUTH OR SALE ######
	}
}
####  END AUTH OR SALE  ####
####  END WS CODE  ###########################################################################


#### START CUSTOMER EMAIL NOTIFICATION ####
function send_order_email($zf_insert_id, $zf_mode, $customer_id) {
	global $currencies, $order_totals, $zco_notifier, $db;

	####  GETTING ORDER ROW  ####
	$order_row = $db->Execute("SELECT * FROM " . TABLE_ORDERS . " WHERE orders_id= '".$zf_insert_id."'");


	####  EMAIL CONFIRMATION INTRO  ####
	$intro =  "Order Confirmation from " . STORE_NAME . "\n\n" . $order_row->fields['customers_name'] . "\n\n" .
                        "Thanks for shopping with us today!" . "\n" . 
                        "The following are the details of your order" . "\n" .
                        "------------------------------------------------------" . "\n".
                        "Order Number: " . $zf_insert_id . "\n". 
                        "Date Ordered: " . strftime(DATE_FORMAT_LONG) . "\n". 
                        "Detailed Invoice: " . zen_href_link(FILENAME_ACCOUNT_HISTORY_INFO, 'order_id=' . $zf_insert_id, 'SSL', false);


	####  COMMENTS  ####
	$comments_row = $db->Execute("SELECT comments FROM " . TABLE_ORDERS_STATUS_HISTORY . " WHERE orders_id= '".$zf_insert_id."'");
	if ($comments_row->fields['comments']) {
		$comments .= "\n\n"."Comments" . "\n" .
                        "------------------------------------------------------" . "\n" .
		nl2br($comments_row->fields['comments']) . "\n\n";
	}


	####  PRODUCT LISTINGS  ####
	$order_products = $db->Execute("SELECT products_name, products_quantity FROM " . TABLE_ORDERS_PRODUCTS . " WHERE orders_id = "."'" .(int)$zf_insert_id."'");
	$products .= "Products" . "\n" .
                        "------------------------------------------------------" . "\n";
	while ( !$order_products->EOF ) {
		$products .= $order_products->fields['products_quantity'] ." x ". $order_products->fields['products_name']."\n" ;
		$order_products->MoveNext();
	}


	####  ORDER TOTALS  ####
	$orders .= "\nOrder totals" . "\n" .
                "------------------------------------------------------" . "\n";
	for ($i=0, $n=sizeof($order_totals); $i<$n; $i++) {
		$orders .= strip_tags($order_totals[$i]['title']) . ' ' . strip_tags($order_totals[$i]['text']) . "\n";
	}


	####  ADDRESS INFORMATION  ####

	####  DELIVERY ADDRESS  ####
	$delivery .= "\nDelivery address" . "\n" .
                        "------------------------------------------------------" . "\n" .
	$order_row->fields["delivery_company"] . "\n" .
	$order_row->fields["delivery_name"] . "\n" .
	$order_row->fields["delivery_street_address"] . "\n" .
	$order_row->fields["delivery_suburb"] . "\n" .
	$order_row->fields["delivery_postcode"] . " " . $order_row->fields["delivery_city"] . "\n" .
	$order_row->fields["delivery_state"] . "\n" .
	$order_row->fields["delivery_country"] . "\n\n" ;


	####  BILLING ADDRESS  ####
	$billing .= "Billing address" . "\n" .
                        "------------------------------------------------------" . "\n" .
	$order_row->fields["billing_company"] . "\n" .
	$order_row->fields["billing_name"] . "\n" .
	$order_row->fields["billing_street_address"] . "\n" .
	$order_row->fields["billing_suburb"] . "\n" .
	$order_row->fields["billing_postcode"] . " " . $order_row->fields["billing_city"] . "\n" .
	$order_row->fields["billing_state"] . "\n" .
	$order_row->fields["billing_country"] . "\n\n" ;


	####  SHIPPING METHOD  ####
	$shipping .= "\n" . "Shipping method" ."\n" .
                        "------------------------------------------------------" . "\n" .
	$order_row->fields["shipping_method"] ."\n\n";


	####  PAYMENT METHOD  ####
	if (is_object($GLOBALS[$_SESSION['payment']])) {
		$payment .= "Payment method" . "\n" .
                "------------------------------------------------------" . "\n";
		$payment_class = $_SESSION['payment'];
		$payment .= $GLOBALS[$payment_class]->title . "\n\n";
		$payment .= ($GLOBALS[$payment_class]->email_footer) ? $GLOBALS[$payment_class]->email_footer . "\n\n" : '';
	} else {
		$payment .= "Payment method" . "\n" .
                "------------------------------------------------------" . "\n" .
		$payment .= PAYMENT_METHOD_GV . "\n\n";
		$payment .= ($GLOBALS[$payment_class]->email_footer) ? $GLOBALS[$payment_class]->email_footer . "\n\n" : '';
	}

	####  DISCLAIMER  ####
	$disclaimer .= "\n-----\n" . sprintf(EMAIL_DISCLAIMER, STORE_OWNER_EMAIL_ADDRESS) . "\n\n";


	####  COPYRIGHT  ####
	$copyright .= "\n-----\n" . EMAIL_FOOTER_COPYRIGHT . "\n\n";


	$email_order = $intro . $comments . $products . $orders . $delivery . $billing . $shipping . $payment . $disclaimer . $copyright;



	while (strstr($email_order, '&nbsp;')) $email_order = str_replace('&nbsp;', ' ', $email_order);


	zen_mail($order_row->fields["customers_name"], $order_row->fields['customers_email_address'], "Order Confirmation No: "
	. $zf_insert_id, $email_order, STORE_NAME, STORE_EMAIL, '', 'netaxept_bbs', '');


	####  UPDATE DATABASE WITH BBS EMAIL NOTIFICATION STATUS  ####
	$sql_orders_status_history = array('orders_id' => $zf_insert_id,
                'orders_status_id' => 1,
                'date_added' => 'now()',
                'customer_notified' => 1,
                'comments' => 'BBS email notification sent OK '.date("Y-m-d G:i:s"));
	zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);

	return "OK";
}
#### END CUSTOMER EMAIL NOTIFICATION ####


   ####  COMPLETE PAYMENT  ####
function completePayment($url, $error) {

	if ($error == "ERROR") {
		// Error
		$url = $url.'&error=error';
	} else if ( $error == "CANCEL" ){
		// Cancel
		$url = $url.'&error=cancel';
	}
	else {	//Payment finished - OK
		unset($_SESSION['sendto']);
		unset($_SESSION['billto']);
	 	unset($_SESSION['shipping']);
	 	unset($_SESSION['payment']);
	 	unset($_SESSION['cart']);
	 	unset($_SESSION['order_number_created']);
	 	unset($_SESSION['order_summary']);
	}
	
	redirect($url);
}
####  END COMPLETE PAYMENT  ####


function redirect($url) {
	header("Location: $url");
	exit;
	/*
	echo "<form name='submitform' action='$url' method='POST'>";
 	echo "<input type='submit' value='Continue the payment process'/>";
 	echo "</form>";
 	echo "<script language='JavaScript'>";
 	echo "document.submitform.submit();";
 	echo "</script>";
 	*/
}  



?>

